%waivers = (
    "cpp-tests/bug14.c" => 1, # we handle GNU commas, GCC doesn't.
    "cpp-tests/bug28.c" => 1, # we handle GNU commas, GCC doesn't.
    "cpp-tests/bug6.c" => 1, # we handle GNU commas, GCC doesn't.
);

for my $file (glob "cpp-tests/*.c") {
    my $tcc = `./tcc -E $file|grep -v '^#'`;
    my $gcc = `gcc -E $file|grep -v '^#'`;
    $tcc =~ s/\\0*([0-9])/\\\1/g;
    $tcc =~ s/[ \n\t]*//msg;
    $gcc =~ s/\\0*([0-9])/\\\1/g;
    $gcc =~ s/[ \n\t]*//msg;

    if ($tcc ne $gcc and
        !$waivers{$file}) {
        print STDERR $tcc . "\n";
        print STDERR $gcc . "\n";
        warn $file;
    }
}
